@ECHO OFF
REM                  ELVISRSS.BAT
REM
REM     Batch file that runs the psion RCOMP resource compiler
REM     for those who do not have the full Psion SDK.  Intended
REM     to allow those working on foreign language variants of
REM     the resource file to work without needing the SDK.
REM
REM     AMENDMENT HISTORY
REM     ~~~~~~~~~~~~~~~~~
REM     28 Jun 1997   - First version


IF "%1" == "" GOTO BADPARAM
IF NOT EXIST help%1.rss GOTO NO_HELP_FILE
IF NOT EXIST elvis%1.rss GOTO NO_RSS_FILE

RCOMP -V -I.  -Selvis%1.rss -Oelvis%1.rsc -Gelvis%1.rsg
RCHUF HWIM -Ielvis%1.rsc -Oelvis%1.rzc
GOTO END

:NO_HELP_FILE
echo .
echo          *** MISSING HELP%1 FILE ***
echo .
echo  Cannot find a file with a name of the form HELP%1.RSS.
echo  Note that this is included from the file ELVIS%1.RSS, so
echo  Check that the correct name is used in that file.
echo .
GOTO BADPARAM

:NO_RSS_FILE
echo .
echo          *** MISSING ELVIS%1 FILE ***
echo .
echo  Cannot find a file with a name of the form ELVISnn.RSS.
echo  The value of nn is language dependent and will be one of
echo .
GOTO BADPARAM

:BADPARAM
echo Syntax:  ELVRCOMP nn
echo    where nn is language variant from one of the following:
echo       01 English (British)  09 Finnish         17 Hungarian
echo       02 French             10 English (USA)   18 Dutch
echo       03 German             11 Swiss French    19 Belgian Flemish
echo       04 Spanish            12 Swiss German    20 Australian
echo       05 Italian            13 Portuguese      21 New Zealand
echo       06 Swedish            14 Turkish         22 Austrian
echo       07 Danish             15 Icelandic       23 Belgian French
echo       08 Norwegian          16 Russian
GOTO END


:END

