#include <plib.h>
#include <unistd.h>

/*
**	The access() function checks the accessibility of the file named
**	by the 'path' argument for the permissions indicated in 'smode',
**	using the real user ID in place of the effective user ID and the
**	real group ID in place of the effective group ID.
**
**	Returns:
**		0 on success and -1 on failure.
**
**	Errors:
**		EACCESS, EINVAL, ENAMETOOLONG, ENOENT, ENOTDIR, EROFS
**/
int
access (const char *path, int amode)
{
	P_INFO info;
	TEXT name[P_FNAMESIZE];
	p_fparse(path,NULL,name,NULL);
	return p_finfo(name, &info);
}

