#include <plib.h>
#include <stdlib.h>
#include <unistd.h>

/*
**	The getcwd() function copies the absolute pathname of the current
**	working directory to the character array pointed to by 'buf'.
**	The 'size' argument is the number of bytes available in 'buf'.
**
**	Returns:
**		'buf' on success and NULL on error.
**
**	Errors:
**		EINVAL, ERANGE, EACCESS
**/
char *
getcwd (char *buf, size_t len)
{
	if (len > P_FNAMESIZE)
		return NULL;
	p_getpth(buf);
	return buf;
}
