#include <plib.h>
#include "unistd.h"
#include "errno.h"
#include "fcntl.h"
#include "lib.h"

extern int errno;

int
open (const char *path, int oflag, ...)
{
    TEXT name[P_FNAMESIZE];
    int fd = 0;
    INT err;
    UINT mode = 0;

    while (_filetable[fd]) {
	fd++;
    }
    p_fparse(path, NULL, name, NULL);
    mode |= P_FSTREAM | P_FRANDOM;
    if (oflag & O_RDONLY)
	mode |= P_FOPEN;
    else if (oflag & O_APPEND)
	mode |= P_FAPPEND | P_FUPDATE;
    else if (oflag & O_RDWR || oflag & O_WRONLY)
	mode |= P_FREPLACE | P_FUPDATE;
    err=p_open(&_filetable[fd], (char *)name, mode);
    if (err >= 0)
	return fd;

    if (oflag & O_APPEND) {
	mode = P_FSTREAM | P_FRANDOM | P_FREPLACE | P_FUPDATE;
	err=p_open(&_filetable[fd], (char *)name, mode);
	if (err >= 0)
	    return fd;
    }

    if (err == E_FILE_NXIST)
	errno = ENOENT;
    return -1;
}
